//------------------------------------------------------------------
//
//    original idea and tradestation code by John Ehlers
//    this version by mladen
//
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2
#property indicator_level1 0

//
//
//
//
//

extern int    BandPassPeriod = 50;
extern int    BandPassPrice  = PRICE_MEDIAN;
extern double Delta          = 0.1;

double bp[];
double prices[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(2);
      SetIndexBuffer(0,bp);
      SetIndexBuffer(1,prices);
      IndicatorShortName("Band pass "+BandPassPeriod+","+DoubleToStr(Delta,2)+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.141592653589793238462643383279
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      double beta    = MathCos(2.0*Pi/BandPassPeriod);
      double gamma   = 1.0 / MathCos(4.0*Pi*Delta/BandPassPeriod);
      double alpha   = gamma -MathSqrt(gamma*gamma-1.0);
   
      //
      //
      //
      //
      //
      
      for(int i=limit; i>=0; i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,BandPassPrice,i);
         bp[i]      = 0.5*(1.0-alpha)*(prices[i]-prices[i+2])+beta*(1.0+alpha)*bp[i+1]-alpha*bp[i+2];
      }               
      return(0);
}